options mprint mlogic symbolgen;
%macro getdays(lib,parm,intrvl,stat,y1,y2,userid,userpasswd,path);
%let rdsn=&lib..ddd&parm.d&y1&y2&intrvl&sysdate;
%let hdsn=&lib..ddh&parm.d&y1&y2&intrvl&sysdate;
%let d1=01-JAN-&y1;
%let d2=31-DEC-&y2;
proc sql;
	 connect to oracle (user=&userid password=&userpasswd path="&path" buffsize=100);
	 create table &rdsn as 
	 select * from connection to oracle (
select	sites.cc_cn_stt_state_code||sites.cc_cn_county_code||sites.site_id as site,
		monitors.poc as poc,
		monitors.pa_parameter_code as parm,
		daily_summaries.sd_duration_code as interval,
		daily_summaries.daily_coll_date as datetime,
		%if &stat=davg %then %do;
		daily_summaries.daily_arith_mean as &stat,
		%end;
		%if &stat=dmax %then %do;
		daily_summaries.daily_max_sample_value as &stat,
		%end;
		daily_summaries.daily_obs_cnt as nobs,
		daily_summaries.daily_obs_pct as pctobs
from	monitors monitors, 
		daily_summaries daily_summaries,
		sites sites
where	monitors.mo_id = daily_summaries.mo_mo_id and
		monitors.status_ind = 'P' and
		sites.si_id = monitors.si_si_id and
		sites.cc_cn_stt_state_code <> 'CC' and
		sites.cc_cn_stt_state_code <> '80' and
		sites.status_ind = 'P' and
		/*daily_summaries.edt_edt_id < 2 and*/ /*we used to excluded ex ev regardless of concurrence*/
		daily_summaries.edt_edt_id in (0,5) and /*now we exclude only those with concurrence*/
		daily_summaries.sd_duration_code = %unquote(%str(%'&intrvl%')) and
		daily_summaries.daily_coll_date >= %unquote(%str(%'&d1%')) and
		daily_summaries.daily_coll_date <= %unquote(%str(%'&d2%')) and
		monitors.pa_parameter_code = %unquote(%str(%'&parm%'))
order by 1, 2, 3, 4);
create table &hdsn as select * from connection to oracle (
select	sites.cc_cn_stt_state_code||sites.cc_cn_county_code||sites.site_id as site, 
		monitors.poc as poc, 
		monitors.pa_parameter_code as parm,
		protocols.sm_methodology_code as method,
		parameters.parameter_desc as parm_name, 
		states.state_name as state_name, 
		counties.county_name as county_name,
		county_cities.ci_city_code as city, 
		cities.city_name as city_name, 
		sites.street_address as address, 
		aqcr_counties.aq_aqcr_code as aqcr, 
		aqcrs.aqcr_desc as aqcr_name, 
		state_urbanized_areas.ua_uar_code as uar, 
		urbanized_areas.uar_name as uar_name,
		land_use_types.land_use_type as land_use, 
		location_settings.location_setting as location, 
		sites.site_latitude as latitude, 
		sites.site_longitude as longitude, 
		sites.utm_zone_num as utm_zone, 
		sites.utm_northing as utm_northing,
		sites.utm_easting as utm_easting,
		sites.ldp_vert_meas as elevation, 
		units.unit as units, 
		units.unit_desc as unit_desc, 
		monitor_type_assignments.mt_monitor_type as type, 
		epa_regions.epa_region_code as region, 
		msas.msa_code as msa,
		msas.msa_population as pop,
		msas.msa_name as msa_name
from	aqcrs aqcrs, 
		aqcr_counties aqcr_counties, 
		cities cities, 
		counties counties, 
		county_cities county_cities, 
		epa_regions epa_regions, 
		land_use_types land_use_types, 
		location_settings location_settings, 
		monitors monitors, 
		monitor_type_assignments monitor_type_assignments,
		monitor_protocols monitor_protocols,
		protocols protocols, 
		msas msas, 
		parameters parameters, 
		states states, 
		state_urbanized_areas state_urbanized_areas, 
		units units, 
		urbanized_areas urbanized_areas, 
		sites sites 
where	aqcrs.aqcr_code = aqcr_counties.aq_aqcr_code and 
		counties.stt_state_code = aqcr_counties.cn_stt_state_code and 
		counties.county_code = aqcr_counties.cn_county_code and 
		cities.city_code = county_cities.ci_city_code and 
		cities.stt_state_code = county_cities.ci_stt_state_code and 
		states.state_code = counties.stt_state_code and 
		msas.msa_code = county_cities.msa_msa_code and 
		epa_regions.epa_region_code = states.epar_epa_region_code and 
		parameters.parameter_code = monitors.pa_parameter_code and 
		monitors.mo_id = monitor_type_assignments.mo_mo_id and 
		monitor_protocols.mo_mo_id = monitors.mo_id and 
		protocols.pro_id = monitor_protocols.pro_pro_id and 
		units.unit = parameters.un_unit_standard and 
		urbanized_areas.uar_code = state_urbanized_areas.ua_uar_code and 
		aqcr_counties.aq_aqcr_code = sites.aqcrc_aq_aqcr_code and 
		aqcr_counties.cn_stt_state_code = sites.aqcrc_cn_stt_state_code and 
		aqcr_counties.cn_county_code = sites.aqcrc_cn_county_code and 
		county_cities.cn_county_code = sites.cc_cn_county_code and 
		county_cities.cn_stt_state_code = sites.cc_cn_stt_state_code and 
		county_cities.ci_city_code = sites.cc_ci_city_code and 
		county_cities.ci_stt_state_code = sites.cc_ci_stt_state_code and 
		location_settings.location_setting = sites.Ls_location_setting and 
		land_use_types.land_use_type = sites.lut_land_use_type and 
		state_urbanized_areas.stt_state_code = sites.sua_stt_state_code and 
		state_urbanized_areas.ua_uar_code = sites.sua_ua_uar_code and 
		sites.si_id = monitors.si_si_id and
		sites.cc_cn_stt_state_code <> 'CC' and
		sites.cc_cn_stt_state_code <> '80' and
		monitors.pa_parameter_code = %unquote(%str(%'&parm%'))
order by 1, 2
); 
%put &sqlxrc; *debug sql;
%put &sqlxmsg; *debug sql;
disconnect from oracle;
quit;
%mend;


libname pmdat 'F:\aqtag\lqn\PM10DesignValues\2003\data';
*pm10;
%getdays(pmdat,81102,7,davg,2001,2003,xxx,password,aqsprod)
run;
%getdays(pmdat,81102,X,davg,2001,2003,xxx,password,aqsprod)
run;
