%macro mapbw(dataset,cntystat);
********************************************************************;
*  black&white map                                                  ;
*  dataset  - SAS dataset containing the criteria pollutant data.   ;
*             Must contain the following variable names:            ;
*             STATE (State FIPS code)                               ;
*             COUNTY (County FIPS code)                             ;
*             The county stat (whatever name given is fine)         ;
*                                                                   ;

********************************************************************;

libname maps 'F:\aqtag\Maps\Special Maps';

************************  MAP  START  ******************************;
goptions reset=all dev=cgmlt97l  gaccess = gsasfile
		 colors=(GRAYFF GRAYEF GRAYBF GRAY00);
          *colors=(CX007700 CXFFFF00 CXFF0000 CX000000);
*filename gsasfile "h:\user\share\mathias\staff paper products\&dn..cgm";
filename gsasfile "F:\aqtag\lqn\PMStaffPaper04\output\bwpm10&cntystat..cgm";


legend1 label=(h=1.1 f=HWCGM002 c=black
               "Concentration ugm3")
        value=(h=1.1 f=HWCGM002 c=black)
        cborder=white cframe=white cshadow=white;

*label &cntystat='00'x;        *-----> unprintable hexadecimal string;
*format &cntystat fmt.;

*------------------------SET UP US MAP----------------------------;
data usmap;
     merge &dataset(in=match) maps.usall2;
     by state county;
     if match = 1 or county = 0;

*--------------------DRAW AND SHADE US MAP------------------------;
proc gmap map=usmap data=&dataset all;
     format &cntystat fmt.;
     id state county;
     choro &cntystat / discrete
                      cempty=black
                      coutline=gray
                      legend=legend1;
pattern value=msolid;
run;
quit;
%mend mapbw;
