libname pmc 'D:\PM NAAQS\summer04\coarse';
libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';

data stpall(keep=site poc_tc zdate pmt pmcr dur_tc method tctype flag_tc);
set pmc.P81102d_0103 (rename=(sdate=zdate))
pmc.P81102_h2d_0103 (rename=(sdate=zdate))
pmc.P81103d_0103 (rename=(sdate=zdate value=pmcr));
if year(zdate) in (2001 2002 2003);
if value ne . or pmcr ne .;
if f1 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag_tc=f1;
else if f2 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag_tc=f2;
poc_tc=poc;
pmt=value;
if hour=1 then  dur_tc='H'; else dur_tc='D';
tctype='S';

proc sql; create table stp2loc as select distinct * from stpall a, staff.presstempall0103b b where a.site=b.site and
a.zdate=b.zdate;
data stp2loc2 (drop=pmcr) dichot (drop=pmt); set stp2loc;
dist_met=dist;
drop dist;
if temperature and pressure ne . then do;
pmt=pmt*298/temperature*pressure/760;
pmcr=pmcr*298/temperature*pressure/760;
end;
else do;
pmt=pmt*298/tempnws*pressnws/760;
pmcr=pmcr*298/tempnws*pressnws/760;
end;
if pmt ne . or pmcr ne .;
if pmt ne . then output stp2loc2;
else do; meth_c=method; output dichot; end;
run;


data ltpall(keep=site poc_tc zdate pmt dur_tc method tctype); 
set pmc.P85101d_0103 (rename=(sdate=zdate))
pmc.P85101_h2d_0103 (rename=(sdate=zdate));
if year(zdate) in (2001 2002 2003);
if value ne .;
if f1 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag=f1;
else if f2 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag=f2;
poc_tc=poc;
pmt=value;
if hour=1 then  dur_tc='H'; else dur_tc='D';
tctype='L';
run;

*keep all records for day;
data pm10all; set ltpall stp2loc2;
meth_t=method;
proc sort; by site;
data pm10all2; merge pm10all pmr.meta (keep=site lat long);
by site;
if zdate ne .;
run;
proc sql; create table tensite as select distinct site,lat,long from pm10all2;

data finedata (keep=site poc_f zdate pmf dur_f meth_f flag_f); 
set pmc.P88101d_0103 (rename=(sdate=zdate))
pmc.P88101_h2d_0103 (rename=(sdate=zdate));
if year(zdate) in (2001 2002 2003);
if value ne .;
if f1 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag_f=f1;
else if  f2 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag_f=f2;
meth_f=method;
pmf=value;
poc_f=poc;
if site not in ('180890022' '180970066' '180970043' '170311016' '171190023' '170990007'  
'440070020' '481410053' '291250001');
if hour=1 then  dur_f='H'; else dur_f='D';
if dur_f='D' and meth_f not in ('116' '117' '118' '119' '120' '123' '142' '143' '144' '145') then delete;
proc sort; by site;
data finedata2; merge finedata pmr.meta (keep=site lat long);
by site;
if zdate ne .;
lat2=lat;
long2=long;
site_f=site;
drop lat long site;
run;
proc sql; create table finesite as select distinct site_f,lat2,long2 from finedata2;

proc sql; create table both as select distinct * from finesite, tensite;
quit;
data cart; set both;
if site = site_f then d=0; 
else do;
 rp=6356.912;d=21.476; 
latR=lat*arcos(-1)/180;    
longR=long*arcos(-1)/180;  
latR2=lat2*arcos(-1)/180;    
longR2=long2*arcos(-1)/180;  

*Polar radius of earth with difference between polar & eq; 
 r=d*(cos(latR2)+cos(latR))*.5+rp;* average radius (km);       
 d=arcos(cos(latR2)*cos(longR2)*cos(latr)*cos(longR)+cos(latR2) 
 *sin(longR2)*cos(latR)*sin(longR)                              
 + sin(latR2)*sin(latR))*r;* distance in km;            
 end;
data closest0103 (keep=site site_f lat long dist_t); set cart;
dist_t=round(d*.62137,.1);
if dist_t ne . and dist_t le 5 then output;
run;
proc sql; create table coarseall as select distinct * from closest0103 a, pm10all2 b, finedata2 c
where a.site=b.site and a.site_f=c.site_f and b.zdate=c.zdate;
quit;
data pmc.coarseall_0103
(keep=site site_f poc_tc poc_f zdate year q lat long dist_t pmt pmf pmc flag_tc flag_f 
meth_t meth_f meth_c 
dur_tc dur_f tctype temperature pressure id dist_met tempnws pressnws );
retain site site_f poc_tc poc_f zdate year q lat long dist_t pmt pmf pmc flag_tc flag_f 
meth_t meth_f meth_c 
dur_tc dur_f tctype temperature pressure id dist_met tempnws pressnws; 
set coarseall pmc.P86101d_0103 (rename=(sdate=zdate value=pmcrl method=meth_c poc=poc_tc))
dichot;
if pmcr ne . then pmc=pmcr;
else if pmcrl ne . then do pmc=pmcrl; tctype='L'; end;
else do; pmc=pmt-pmf; end;
if pmc ne .;
if dur_f=' ' and dur_tc=' ' then dur_tc ='D';
q=qtr(zdate);
year=year(zdate);
if year=2002 then q=q+4;
if year=2003 then q=q+8;
run;


/*
proc sql; create table howmany as select distinct meth_c,meth_t,meth_f,count(*) as numsamp
from coarseall2 group by meth_c,meth_t, meth_f;
quit;
proc sort; by meth_t;
proc sql; create table a as select distinct pa_parameter_code as parm, methodology_code as meth,
sample_coll_desc as coll,sample_anal_desc as anal from aqs.sampling_methodologies; quit;
data b; set a;
meth_t=meth;
coll_t=coll;
anal_t=anal;
if parm='81102';
proc sort; by meth_t;
data hm2; merge howmany b; by meth_t;
if numsamp ne .;
if coll ne ' ';
proc sort; by meth_t meth_f meth_c;
data b; set a;
meth_f=meth;
coll_f=coll;
anal_f=anal;
if parm='88101';
proc sort; by meth_f;
proc sort data=howmany; by meth_f;
data hm3; merge howmany b; by meth_f;
if numsamp ne .;
if coll ne ' ';
proc sort; by meth_t meth_f meth_c;
data b; set a;
meth_c=meth;
coll_c=coll;
anal_c=anal;
if parm='81103';
proc sort; by meth_c;
proc sort data=howmany; by meth_c;
data hm4; merge howmany b; by meth_c;
if numsamp ne .;
if coll ne ' ';
proc sort; by meth_t meth_f meth_c;
data b; set a;
meth_c=meth;
coll_c=coll;
anal_c=anal;
if parm='86101';
proc sort; by meth_c;
proc sort data=howmany; by meth_c;
data hm5; merge howmany b; by meth_c;
if numsamp ne .;
if coll ne ' ';
proc sort; by meth_t meth_f meth_c;
data hm; merge hm2 hm3 hm4 hm5; by meth_t meth_f meth_c;
run;
data test2; set test;
meth_t=meth_ten;
meth_f=meth_fine;
proc sort; by meth_t meth_f;
proc sort data=hm; by meth_t meth_f;
data it; merge test2 hm; by meth_t meth_f;
if numsamp ne .;
run;
proc sql; create table aa as select distinct * from hm a, test b where a.meth_t=b.meth_ten and a.meth_f=b.meth_fine;
quit;
*/