* this code generates the number of counties and associated populations that do not meet the annual and 24-hour pm10 naaqs
based on the 01-03 data;

libname pm 'F:\aqtag\lqn\PM10DesignValues\2003\output';
libname pop 'F:\aqtag\CensusData';


data prep;
	 keep state county eaam eeex;
	 *set pm.pm102003appk_bysite09nov04; *include all data;
	 set pm.pm102003appk_bysite01nov04; *include flagged data concurrd by regions;
	 if comp3yrs then eaam=.; *annual means are only valid for sites with complete data, exp.exc. are valid for all sites regardless of completeness;
	 state=input(substr(site,1,2),2.);
	 county=input(substr(site,3,3),3.);
proc sort; by state county;

proc univariate noprint;
	 by state county;
	 var eaam eeex;
	 output out=ctylevel max=maxctyann maxctyexc;
run;

proc sort data=pop.county19902000 out=popdata;
	 by state county;
run;

data all;
	 merge popdata ctylevel (in=incty);
	 by state county;
	 if incty;
run;
proc print u n noobs;
	 var state county stname ctyname pop2000 maxctyann maxctyexc;
	 sum pop2000;
	 where maxctyann gt 50;
title 'Counties not meeting PM10 Annual NAAQS, 2001-2003';
run;
proc print u n noobs;
	 var state county stname ctyname pop2000 maxctyann maxctyexc;
	 sum pop2000;
	 where maxctyexc gt 1;
title 'Counties not meeting PM10 24-hour NAAQS, 2001-2003';
run;
proc print u n noobs;
	 var state county stname ctyname pop2000 maxctyann maxctyexc;
	 sum pop2000;
	 where maxctyann gt 50 or maxctyexc gt 1;
title 'Counties not meeting PM10 Annual or 24-hour NAAQS, 2001-2003';
run;
* to get total # of counties with PM10 data and associated population;
proc print u n noobs;
	 sum pop2000;
run;
