libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmc 'D:\PM NAAQS\summer04\coarse';

*get complete sites;
data a (keep= site st cou in dv_p98 dv_p99 level);
set staff.Peaks_0103c;
if numq_n11=12;
st=substr(site,1,2);
cou=substr(site,3,3);
in=1;
int=round(dv_p99,1);
if int le 20 then level='a';
else if int le 25 then level='b';
else if int le 30 then level='c';
else if int le 35 then level='d';
else if int le 40 then level='e';
else if int le 45 then level='f';
else if int le 50 then level='g';
else if int le 55 then level='h';
else if int le 60 then level='i';
else if int le 65 then level='j';
else level='k';
run;
proc sort; by site;

*get raw data for complete sites;
data b; set y.Pm25d12jul04colo;
if meth in (116 117 118 119 120 123 142 143 144 145);
if f1 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag=f1;
else if  f2 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag=f2;
proc sort; by site;
run;
data raw;  merge a (keep=site in dv_p98 dv_p99 level) b (keep=site zdate flag v); by site;
if in=1;
*if v gt dv_p98;
run;
proc sort; by level;

/*
proc univariate noprint data=raw;
by level;
var v;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
run;
data staff.boxdata_intp98;
set uniout;
data a; set uniout;
DO I=1 TO 10;
val=pct95; output;
val=pct05; output;
END;
do i=1 to 26;
val=pct25; output;
val=pct75; output;
val=median; output;
END;
VAL=MIN; OUTPUT;
VAL=MAX; OUTPUT;
run;
run;
GOPTIONS reset=all dev=gif
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
symbol i=box05t bwidth=5 v=none;
axis1 label=none offset=(5) minor=none value=none;
axis2 label=none order=(0 to 140 by 10) c=black;
run;

filename gsasfile "d:\pm naaqs\summer04\box_valhi_by_p99.gif";

proc gplot data=a;
plot val * level /
vref=(10 20 30 40 50 60 70 80 90 100 110 120 130)
lvref=3
haxis=axis1
vaxis=axis2;
run;
quit;

proc sql; create table a as select level,count(*) as tot from raw group by level;
proc sql; create table b as select level,count(*) as flagged from raw where flag ne ' ' group by level;
data c; merge a b; by level;
pflag=flagged/tot;
run;
*/


proc sql; create table a as select distinct level,site,count(*) as tot from raw group by level,site;
create table b as select distinct level,site,count(*) as gt5 from raw where v gt dv_p98+5 group by level,site;
create table c as select distinct level,site,count(*) as le5 from raw where v le dv_p98+5 group by level,site;
create table cc as select distinct level,site,count(*) as le5hi from raw where v le dv_p98+5 and v ge dv_p98 group by level,site;quit;

data d; merge a b c cc; by level site; 
if le5hi=. then le5hi=0;
if gt5=. then gt5=0;
pgt5=gt5/tot;
ple5hi=le5hi/tot;
data e; set d; level=' ';
data f; set d e;

proc sort; by level;
proc means noprint; by level;
var gt5 pgt5 le5hi ple5hi ;
output out=tab 
n=n
min=min_gt5 min_pgt5 min_le5hi min_ple5hi 
mean=mean_gt5 mean_pgt5 mean_le5hi mean_ple5hi 
max=max_gt5 max_pgt5 max_le5hi max_ple5hi;

run;



proc sql; create table a as select distinct level,site,count(*) as tot from raw group by level,site;
create table b as select distinct level,site,count(*) as gt5 from raw where v gt dv_p99+5 group by level,site;
create table c as select distinct level,site,count(*) as le5 from raw where v le dv_p99+5 group by level,site;
create table cc as select distinct level,site,count(*) as le5hi from raw where v le dv_p99+5 and v ge dv_p99 group by level,site;quit;

data d; merge a b c cc; by level site; 
if le5hi=. then le5hi=0;
if gt5=. then gt5=0;
pgt5=gt5/tot;
ple5hi=le5hi/tot;
data e; set d; level=' ';
data f; set d e;

proc sort; by level;
proc means noprint; by level;
var gt5 pgt5 le5hi ple5hi ;
output out=tab2 
n=n
min=min_gt5 min_pgt5 min_le5hi min_ple5hi 
mean=mean_gt5 mean_pgt5 mean_le5hi mean_ple5hi 
max=max_gt5 max_pgt5 max_le5hi max_ple5hi;

run;