libname pmc 'D:\PM NAAQS\summer04\coarse';
libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';

data tempraw; set pmc.pmc_raw_dayagg_1284;
pmc=round(pmc,1);
poc=0; 
run;
proc sort; by site;
proc sql; create table aa as select distinct site,poc,count(*) as flagct from tempraw
where flag ne ' ' group by site,poc;
quit;
proc sql; create table bb as select distinct site,poc,count(*) as tot from tempraw
group by site,poc;
quit;
proc sql; create table aa2 as select distinct site,count(*) as flagct from tempraw
where flag ne ' ' group by site;
quit;
proc sql; create table bb2 as select distinct site,count(*) as tot from tempraw
group by site;
quit;

data raw; set pmc.pmc_rawbysite_colonocont_1284;
if flag_tc ne ' ' then flag=flag_tc;
else flag=flag_f;
proc sql; create table aa3 as select distinct site,poc_tc as poc,count(*) as flagct from raw
where flag ne ' ' group by site,poc;quit;
quit;
proc sql; create table roles as select distinct mo_mo_id as mo_id,sa_ag_agency_code as ro,
agency_role_begin_date from aqs.agency_roles where rol_role='REPORTING'; quit;
proc sort; by mo_id agency_role_begin_date;
data roles2; set roles; by mo_id agency_role_begin_date;
if last.mo_id;
run;
proc sql; create table agency as select distinct a.site,poc,ro from pmr.allmonitors a, roles2 b 
where a.mo_id=b.mo_id and a.pa_parameter_code in ('88101' '81102')
and ro ne ' ';
create table ro as select distinct ro from agency a, aa3 where a.site=aa3.site and a.poc=aa3.poc
and aa3.flagct ne .;
proc sql;
create table sites as select distinct site,poc,b.ro from agency a, ro b where a.ro=b.ro;
quit;
proc sort; by site poc;
data sites2; set sites; by site poc;
if first.site;
run;

data csites (keep= site dvnf_mean dvnf_p95 dvnf_p96 dvnf_p97 dvnf_p98 dvnf_p99
dv_mean dv_p95 dv_p96 dv_p97 dv_p98 dv_p99
flagct tot ro)
nsites (keep=site);
merge pmc.Pmc_basenf_1284 aa2 bb2 sites2; by site;
rename annmeanpmcnf=dvnf_mean pmcnf_95=dvnf_p95 pmcnf_96=dvnf_p96 pmcnf_97=dvnf_p97 pmcnf_98=dvnf_p98 pmcnf_99=dvnf_p99
annmeanpmc=dv_mean pmc_95=dv_p95 pmc_96=dv_p96 pmc_97=dv_p97 pmc_98=dv_p98 pmc_99=dv_p99;
if annmeanpmc ne .;
*if substr(site,1,5)='06073';
*if dv_mean lt 15.1;
if ro ne ' ';
*if pmc_98 lt 50;
if flagct=. then flagct=0;
*if flagct ne 0;
if flagct ne 0 then output csites; else output nsites;
run;
data csites2; set csites;
if dv_mean gt 15 and dvnf_mean le 15;
st=substr(site,1,2);
cou=substr(site,3,3);
proc sort; by st cou;
data csites3; merge csites2 r.cbsa_reference; by st cou;
if dv_mean gt 15;
run;

run;

/*
data all (keep=site v flag_f zdate); merge csites tempraw; by site;
if dv_mean ne .;
*if substr(site,1,5)='06073';
if flag ne ' ';
proc sort; by descending v;
run;
*/

proc sql; select distinct site,count(*) from csites group by site having count(*) gt 1; quit;

proc sql; create table c as select distinct a.site,count(*) as ge95 from csites a, tempraw b
where a.site=b.site and pmc ge dv_p95 group by a.site;
create table c2 as select distinct a.site,count(*) as ge95f from csites a, tempraw b
where a.site=b.site and pmc ge dv_p95 and flag ne ' ' group by a.site;
quit;


proc sql; create table d as select distinct a.site,count(*) as ge96 from csites a, tempraw b
where a.site=b.site and pmc ge dv_p96 group by a.site;
create table d2 as select distinct a.site,count(*) as ge96f from csites a, tempraw b
where a.site=b.site and pmc ge dv_p96 and flag ne ' ' group by a.site;
quit;

proc sql; create table e as select distinct a.site,count(*) as ge97 from csites a, tempraw b
where a.site=b.site and pmc ge dv_p97 group by a.site;
create table e2 as select distinct a.site,count(*) as ge97f from csites a, tempraw b
where a.site=b.site and pmc ge dv_p97 and flag ne ' ' group by a.site;
quit;

proc sql; create table f as select distinct a.site,count(*) as ge98 from csites a, tempraw b
where a.site=b.site and pmc ge dv_p98 group by a.site;
create table f2 as select distinct a.site,count(*) as ge98f from csites a, tempraw b
where a.site=b.site and pmc ge dv_p98 and flag ne ' ' group by a.site;
quit;

proc sql; create table g as select distinct a.site,count(*) as ge99 from csites a, tempraw b
where a.site=b.site and pmc ge dv_p99 group by a.site;
create table g2 as select distinct a.site,count(*) as ge99f from csites a, tempraw b
where a.site=b.site and pmc ge dv_p99 and flag ne ' ' group by a.site;
quit;


data ge; merge csites c c2 d d2 e e2 f f2 g g2;
by site;
array gef(5) ge95f ge96f ge97f ge98f ge99f;
do i=1 to 5;
if gef(i)=. then gef(i)=0;
end;
pf=flagct/tot;
pge95f=ge95f/ge95;
pge96f=ge96f/ge96;
pge97f=ge97f/ge97;
pge98f=ge98f/ge98;
pge99f=ge99f/ge99;
run;
proc univariate data=ge noprint;
var pf pge95f pge96f pge97f pge98f pge99f;
output out=tab n=n1-n6 mean=mean_f mean_f95-mean_f99 median=med_f med_f95-med_f99 q1=p25f p25f_95-p25f_99 q3=p75f p75f_95-p75f_99;
run;

data diff ;
set csites;
array flag(6) dvnf_mean dvnf_p95 dvnf_p96 dvnf_p97 dvnf_p98 dvnf_p99;
array reg(6) dv_mean dv_p95 dv_p96 dv_p97 dv_p98 dv_p99;
array diff(6) diffmean diffp95 diffp96 diffp97 diffp98 diffp99;
*if substr(site,1,1) ne '7';
do i=1 to 6;
diff(i)=reg(i) - flag(i);
end;
run;
PROC TRANSPOSE DATA=DIFF; BY SITE;
run;

proc univariate DATA=DIFF noprint;
var diffmean diffp95 diffp96 diffp97 diffp98 diffp99 ;
output out=diff2
max=maxdiffmean maxdiffp95 maxdiffp96 maxdiffp97 mxdiffp98 maxdiffp99
mean=meandiffmean meandiffp95 meandiffp96 meandiffp97 meandiffp98 meandiffp99
min=mindiffmean mindiffp95 mindiffp96 mindiffp97 mindiffp98 mindiffp99
q1=q1diffmean q1diffp95 q1diffp96 q1diffp97 q1diffp98 q1diffp99
q3=q3diffmean q3diffp95 q3diffp96 q3diffp97 q3diffp98 q3diffp99
median=meddiffmean meddiffp95 meddiffp96 meddiffp97 meddiffp98 meddiffp99
p5=p5diffmean p5diffp95 p5diffp96 p5diffp97 p5diffp98 p5diffp99
p95=p95diffmean p95diffp95 p95diffp96 p95diffp97 p95diffp98 p95diffp99
n=ndiffmean ndiffp95 ndiffp96 ndiffp97 ndiffp98 ndiffp99;
RUN;


proc sql; create table flags as select distinct flag, count(*) as ct from tempraw  group by flag;
proc sort data=r.flags; by flag_f;
data flags2;
length flag_f $2.;
merge flags r.flags (rename=(flag_f=flag)); by flag;
if ct ne .;
run;
proc sort; by flag;
proc sql; create table sitef as select distinct site,flag from tempraw;
create table sitef2 as select distinct flag,count(*) as numsites from sitef group by flag;

data flags3; merge flags2 sitef2; by flag;

proc sort; by descending ct;
run;
proc sql; create table flags as select distinct flag, count(*) as ct from tempraw a,
csites b where a.site = b.site group by flag;
proc sort data=r.flags; by flag_f;
data flags2;
length flag_f $2.;
merge flags r.flags (rename=(flag_f=flag)); by flag;
if ct ne .;
run;
proc sort; by flag;
proc sql; create table sitef as select distinct a.site,flag from tempraw a, csites b where a.site=b.site; 
create table sitef2 as select distinct flag,count(*) as numsites from sitef group by flag;
data flags4; merge flags2 sitef2; by flag;
run;
proc sort; by descending ct;
run;

data csites; set csites; f=1;
proc sort data=csites; by site;
data nsites; set nsites; n=1;
proc sort data=nsites; by site;
proc sort data=tempraw; by site;
data merg; merge csites nsites tempraw; by site;
if n =1 or f=1;
data merg2; set merg;
if f=1 then lev=2;
else if n=1 then lev=3;
data flags; set merg;
if flag ne ' ';
lev=4;
run;
data merg3; set merg merg2 flags;
if lev=. then lev=1;
proc sql; select lev,count(*) from merg3 group by lev; quit;
proc sort data=merg3; by lev;
proc univariate noprint data=merg3;
by lev;
var pmc;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
run;
data a; set uniout;
DO I=1 TO 10;
val=pct95; output;
val=pct05; output;
END;
do i=1 to 26;
val=pct25; output;
val=pct75; output;
val=median; output;
END;
VAL=MIN; OUTPUT;
VAL=MAX; OUTPUT;
run;
GOPTIONS reset=all dev=gif
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
symbol i=box05t bwidth=12 v=none;
axis1 label=none offset=(15) minor=none value=none;
axis2 label=none order=(0 to 110 by 10) c=black;
run;

filename gsasfile "d:\pmr\box_events_uni1.gif";

proc gplot data=a;
plot val * lev /
vref=(10 20 30 40 50 60 80 90 100)
lvref=3
haxis=axis1
vaxis=axis2;
run;
quit;
proc transpose data=uniout out=trans; 
run;



proc sql; create table site as select distinct site from merg3 where lev=3; quit;

proc transpose data =diff out=test;
run;


proc univariate data=pmc.Pmc_basenf_1284 noprint;
var pmc_98;

output out=tab pctlpre=p_ PCTLPTS=80to 100 by 1;
run;

data a; set sp.Pmc_raw_0103;
proc sort; by site zdate descending tctype;
st=substr(site,1,2);
cou=substr(site,3,3);
proc sort; by site;
data b; merge a pmr.meta; by site;
if st ne ' ';
proc sort; by descending pmc;
run;
data c; set b (obs=100);
if flag ne ' ' then fit=1;
run;
proc sql; select pmregdesc,fit,count(*) from c group by pmregdesc,fit;
quit;


proc sort data=pmc.pmc_raw_dayagg_1284; by descending pmc; run;
data a; set pmc.pmc_raw_dayagg_1284 (obs=1000);
proc sql; select count(*) from a where flag ne ' ';
quit;
