/*data coarc (keep=site state county pmcdv98); set sp.Pmc_dv;
state=substr(site,1,2)+0;
county=substr(site,3,3)+0;
proc sort; by state county descending pmcdv98;
data coarse; set coarc;
by state county descending pmcdv98;
if first.county;
p98=pmcdv98;
run;
*/
/*data coarc (keep=site state county annmeanpmc); set pmc.Pmc_levbase_1284;
state=substr(site,1,2)+0;
county=substr(site,3,3)+0;
proc sort; by state county descending annmeanpmc;
data coarse; set coarc;
by state county descending annmeanpmc;
if first.county;
amean=round(annmeanpmc,.1);
run;
*/

/*data fin (keep=site state county p98 amean lev); set  staff.Peaks_0103c (drop=state);
state=substr(site,1,2)+0;
county=substr(site,3,3)+0;
amean=round(dv_mean,.1);
p98=round(dv_p98,1);
if numq_n11=12;
st=substr(site,1,2);
cou=substr(site,3,3);
if site in ('180890022' '180970066' '180970043' '170311016' '171190023' '170990007'  
'440070020' '481410053' '291250001') then amean=.;
if p98 le 30 then lev=1;
else if p98 le 40 then lev=2;
else if p98 le 65 then lev=3;
else lev=4;
proc sort; by state county descending p98;
data fine; 
set fin; 
by state county descending p98;
if first.county;
run;
*/
data fin (keep=site state county p98 amean lev); set  staff.Peaks_0103c (drop=state);
state=substr(site,1,2)+0;
county=substr(site,3,3)+0;
amean=round(dv_mean,.1);
p98=round(dv_p98,1);
if numq_n11=12;
st=substr(site,1,2);
cou=substr(site,3,3);
*if site in ('180890022' '180970066' '180970043' '170311016' '171190023' '170990007'  
'440070020' '481410053' '291250001') then amean=.;
if amean le 12 then lev=1;
else if amean le 15 then lev=2;
else if amean le 18 then lev=3;
else lev=4;
proc sort; by state county descending amean;
data fine; 
set fin; 
by state county descending amean;
if first.county;
run;
%macro mapit(dataset,cntystat,dn);
********************************************************************;
*  black&white map                                                  ;
*  dataset  - SAS dataset containing the criteria pollutant data.   ;
*             Must contain the following variable names:            ;
*             STATE (State FIPS code)                               ;
*             COUNTY (County FIPS code)                             ;
*             The county stat (whatever name given is fine)         ;
*                                                                   ;

********************************************************************;
libname map 'g:\user\share\schmidty';

************************  MAP  START  ******************************;
goptions reset=all dev=cgmflwa  gaccess = gsasfile
          colors=(white grayef graybf gray00);


filename gsasfile "d:\pm naaqs\summer04\&dn..cgm";

%if %upcase(&dataset) eq FINE and %upcase(&cntystat) eq AMEAN  %then %do;
proc format;
value fmt
 low - 12="x <= 12"
 12.1 -  15="12 < x <= 15"
 15.1 -  18="15 < x <= 18"
 18.1 - high="x > 18";
%end;
%else %if %upcase(&dataset) eq FINE and %upcase(&cntystat) eq P98  %then %do;
proc format;
value fmt
 low - 30="x <= 30"
 31 -  40="30 < x <= 40"
 41 -  65="40 < x <= 65"
 66 - high="x > 65";
%end;
%else %if %upcase(&dataset) eq COARSE and %upcase(&cntystat) eq AMEAN  %then %do;
proc format;
value fmt
 low - 10="x <= 10"
 10.1 -  15="10 < x <= 15"
 15.1-  25="15 < x <= 25"
 25.1 - high="x > 25";
%end;
%else %if %upcase(&dataset) eq COARSE and %upcase(&cntystat) eq P98  %then %do;
proc format;
value fmt
 low - 25="<= 25"
 26 -  45="25 < x <= 45"
 46 -  75="45 < x <= 75"
 76 - high="x > 75";
%end;
%else %if %upcase(&dataset) eq TEN and %upcase(&cntystat) eq AMEAN  %then %do;
proc format;
value fmt
 low - 20="0 < x <= 20"
 20.1 -  30="20 < x <= 30"
 30.1 -  50="30 < x <= 50"
 50.1 - high="x > 50";
%end;
%else %if %upcase(&dataset) eq TEN and %upcase(&cntystat) eq P98  %then %do;
proc format;
value fmt
 low - 50="0 < x <= 50"
 51 -  75="50 < x <= 75"
 76 -  150="75 < x <= 150"
 151 - high="x > 150";
%end;
run;

proc sort data=&dataset; by state county;

legend1 label=(h=1.1 f=HWCGM002 c=black
               "Concentration ug/m3")
        value=(h=1.1 f=HWCGM002 c=black)
        cborder=white cframe=white cshadow=white;

label &cntystat='00'x;        *-----> unprintable hexadecimal string;
format &cntystat fmt.;


*------------------------SET UP US MAP----------------------------;
data usmap;
     merge &dataset(in=match) map.usall2 ;
     by state county;
     if match = 1 or county = 0;
proc sort; by &cntystat;
*--------------------DRAW AND SHADE US MAP------------------------;
proc gmap map=usmap data=&dataset all;
     format &cntystat fmt.;
     id state county;
     choro &cntystat / discrete
                      cempty=black
                      coutline=gray
legend=legend1;
pattern value=msolid;
run;
quit;


%mend;

%mapit(fine,amean,fineamean);

run;
quit;
proc sql; select distinct lev,count(*) from fine group by lev; quit;