libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmc 'D:\PM NAAQS\summer04\coarse';

data coarse (keep=site state county p98 int level); set  staff.Peaks_0103c (drop=state);
state=substr(site,1,2)+0;
county=substr(site,3,3)+0;
int=round(annmean,.1);
if int le 6 then level='a';
else if int le 8 then level='b';
else if int le 10 then level='c';
else if int le 12 then level='d';
else if int le 14 then level='e';
else if int le 16 then level='f';
else if int le 20 then level='g';
else if int le 30 then level='h';
else level='i';

proc sort; by level;
proc univariate noprint data=fine;
by level;
var p98;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
run;

data a; set uniout;
if level in ('a' 'c' 'j') then min=min-.01;
DO I=1 TO 10;
val=pct95; output;
val=pct05; output;
END;
do i=1 to 26;
val=pct25; output;
val=pct75; output;
val=median; output;
END;
VAL=MIN; OUTPUT;
VAL=MAX; OUTPUT;
run;

GOPTIONS reset=all dev=gif
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
symbol i=box05t bwidth=5 v=star;
axis1 label=none offset=(3) minor=none value=none;
axis2 label=none order=(0 to 80 by 10) c=black;
run;

filename gsasfile "d:\pm naaqs\summer04\box_fine98_intamean.gif";

proc gplot data=a;
plot val * level /
vref=(10 20 30 40 50 60 70 )
lvref=3
haxis=axis1
vaxis=axis2;
run;
quit;
