libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmc 'D:\PM NAAQS\summer04\coarse';

data a; set staff.Pm102003dvs_bysite15jul04;
run;
data b (keep=site poc eaam); set staff.Pm10dvannual;
run;

data tempraw; set pmc.pmc_raw_dayagg_1284;
pmc=round(pmc,1);
if flag eq ' ';
q=qtr(zdate);
y=year(zdate);
IF y=2002 then q=q+4;
if y=2003 then q=q+8;
proc sort; by site;
run;
proc sql; create table cts as select distinct bq,eq,maxnq11 as numq,a.site,count(*) as ct,annmeanpmt,annmeanpmc,annmeanpmf from 
tempraw a,pmc.Pmc_levelssite_colonocont_1284 b where a.site=b.site
group by a.site order by site; quit;
data traw2; merge tempraw cts; by site;
if numq=4 then do;
y=1;
end;
else if numq=8 then do;
if q le bq+3 then y=1;
else y=2;
end;
else if numq=12 then do;
if q le 4 then y=1;
else if q le 8 then y=2;
else y=3;
end;
run;
data cts2; set cts;
cut=347;
if numq=4 then cut=cut/3;
else if numq=8 then cut=cut*2/3;
if ct le cut then x=1;
else if ct le 2*cut then x=2;
else if ct le 3*cut then x=3;
else if ct le 4*cut then x=4;
else fu=1;
run;
proc sort; by site; run;
data traw3; merge cts2 traw2 pmr.meta; by site;
if x ne .;
*if pmreg ne 0;
if pmreg in (1 2 3 4) then ew='east';
else if pmreg in (5 6 7)then ew='west';
run;
proc sort data=traw3; by site descending pmc;
data pmcdvee (keep=site pmcdvee ct ew pmreg pmregdesc); set traw3; by  site descending pmc;
if first.site then do; i=0; np=0; end;
nc98=ct-int(.98*ct);
i+1;
if i=x then do;
pmcdvee=pmc;
output pmcdvee;
end;
run;
proc sql; create table ctsbyy as select distinct site,y,count(*) as ct from traw3 group by site,y;
proc sort data=traw3; by site y;
data traw4; merge traw3 (drop=ct) ctsbyy; by site y;
run;
proc sort data=traw4; by site numq y descending pmc;
data pmc99 (keep=site numq y pmc99 nc99 ct) pmc98 (keep=site numq y pmc98 nc98 ct) 
pmc97 (keep=site numq y pmc97 nc97 ct) pmc96 (keep=site numq y pmc96 nc96 ct)
pmc95 (keep=site numq y pmc95 nc95 ct);
set traw4;
by site numq y descending pmc;
pmc=round(pmc,1);
if first.y then do; i=0; nc95=0; nc96=0; nc97=0; nc98=0; nc99=0; end;
nc99=ct-int(.99*ct);
nc98=ct-int(.98*ct);
nc97=ct-int(.97*ct);
nc96=ct-int(.96*ct);
nc95=ct-int(.95*ct);
i+1;
if i=nc99 then do; 
pmc99=pmc;
output pmc99;
end;
if i=nc98 then do; 
pmc98=pmc;
output pmc98;
end;
if i=nc97 then do; 
pmc97=pmc;
output pmc97;
end;
if i=nc96 then do; 
pmc96=pmc;
output pmc96;
end;
if i=nc95 then do; 
pmc95=pmc;
output pmc95;
end;

run;
data both; set pmc99 pmc98 pmc97 pmc96 pmc95;
proc sort; by site numq;
proc means noprint; by site numq;
var pmc99 pmc98 pmc97 pmc96 pmc95;
output out=pmcdv_perdv mean=pmcdv99 pmcdv98 pmcdv97 pmcdv96 pmcdv95 n=n;
run;

data sp.pmc_dv; set pmcdv_perdv;
array roundit(5) pmcdv99 pmcdv98 pmcdv97 pmcdv96 pmcdv95;
do i=1 to 5;
roundit(i)=round(roundit(i),1);
end;
run;


data pmc; merge pmcdvee pmc_perdv;run;
proc sort data=traw3; by site descending pmt;
data pmtdvee (keep=site pmtdvee x); set traw3; by  site descending pmt;
if first.site then do; i=0; end;
i+1;
if i=x then do;
pmtdvee=pmt;
output;
end;
run;
proc sort data=traw3; by site numq y descending pmt;
data pmt99 (keep=site numq pmt99 y nc99 ct); set traw3;
by site numq y descending pmt;
if first.y then do; i=0; np=0; end;
nc99=ct-int(.99*ct);
i+1;
if i=nc99 then do; 
pmt99=pmt;
output;
end;
run;

proc means noprint; by site numq;
var pmt99;
output out=pmtdv99 mean=pmtdv99 n=n;
run;
data pmt; merge pmtdvee pmtdv99; by site;
run;

proc sort data=a; by site descending dv24;
data pm10dvee; set a; by site descending dv24;
if first.site;

proc sort data=b; by site descending eaam;
data pm10dvam; set b; by site descending eaam;
if first.site;
data avg (keep=site annmeanpmt annmeanpmc annmeanpmf); set cts; run;
data all; merge pmc pmt pm10dvee pm10dvam avg; by site;
if ct ne .;
if max1 ne .;
ratpmcee2pmtee=pmcdvee/pmtdvee;
ratpmc982pmtee=pmcdv98/pmtdvee;
ratpmc992pmtee=pmcdv99/pmtdvee;
ratpmcee2pmtdv24=pmcdvee/dv24;
ratpmc982pmtdv24=pmcdv98/dv24;
ratpmc992pmtdv24=pmcdv99/dv24;
ratpmtee2pmtdv24=pmtdvee/dv24;
st=substr(site,1,2);
cou=substr(site,3,3);
/*if ew='east' then east=pmtdvee;
else if ew='west' then west=pmtdvee;
else delete;*/
if ew='east' then east=pmtdvee;
else if ew='west' then west=pmtdvee;
else delete;
*if pmtdvee ge 100;
*if pmtdvee le 300;

run;


GOPTIONS reset=all dev=gif
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
filename gsasfile "D:\pm naaqs\summer04\pmc equiv pmt.gif";
symbol1 v=star i=none c=red;
symbol2 v=none i=rl c=red;
symbol3 v=star i=none c=blue;
symbol4 v=none i=rl c=blue;
symbol5 v=none i=rl c=black;
*title 'all pmt levels';
*title 'pmt ge 100';
title 'pmt ge 100, le 300';
axis1 label=('PM10 DV, ug/m3');
axis2 label=('PM10-2.5 DV98, ug/m3');
proc gplot data=all;
plot (west west) * pmcdv99
(east east) * pmcdv99
pmtdvee * pmcdv99
/ overlay
/*vref=(65)
href=(15)
lvref=(3)
lhref=(3)*/
vaxis=axis1
haxis=axis2;
run;
quit;
proc reg data=all;
model pmcdv99=east;
proc reg data=all;
model pmcdv99=west;
proc reg data=all;
model pmcdv99=pmtdvee;
run;
quit;

DATA ALL; SET ALL; PMREG=1;


proc sort data=all; by pmreg;
GOPTIONS reset=all dev=cgmflwa
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
symbol i=box05t bwidth=75 v=none;
axis2 label=('Ratio') order=(0 to 1 by .1) minor=none  c=black;
axis1 label=none value=none offset=(5) /*order=(1 to 7 by 1)*/ minor=none;
filename gsasfile "d:\pm naaqs\summer04\box_ratio.cgm";
*title 'Ratio of PMC_DV_99 (12,8,4) / PMT_DV_EE (real0103), by region';
*title 'Ratio of PMC_DV_98 / PMT_DV_EE, by region';
title 'Ratio of PMC_DV_99 / PMT_DV_EE, all sites';

proc gplot data=all;
*where numq=12;
plot ratpmc992pmtee * pmreg /
vref=(.1 .2 .3 .4 .5 .6 .7 .8 .9)
lvref=3
haxis=axis1
vaxis=axis2;
run;
quit;
proc sql; select distinct pmreg,pmregdesc from all; quit;

proc sort data=all; by st cou;
data all2; merge all r.cbsa_reference; by st cou;
if ct ne .;
if csa ne ' ' then area=csa_name;
else delete;
array dat (5) pmtdvee dv24 pmcdvee pmcdv98 pmcdv99;
do i=1 to 5;
dat(i)=round(dat(i),1);
end;
run;
proc sql; create table staff.equiv_by_CSA as select distinct ew,area,csa,count(*) as numsites,max(dv24) as pmtdvee_real,max(eaam) as pmtdvam_real,max(pmtdvee) as pmtdvee,
max(pmcdvee) as pmcdvee, max(pmcdv98) as pmcdv98, max(pmcdv99) as pmcdv99, avg(annmeanpmc) as avgpmc,
avg(annmeanpmt) as avgpmt, avg(annmeanpmf) as avgpmf from all2 group by ew,area
order by ew,area; quit;

proc sql; select distinct y,count(*) from traw3 where site='010972005' group by y; quit;

proc univariate noprint data=all;
var ratpmc982pmtee ratpmc992pmtee;
output out=tab mean=mean98 mean99 p95=p95_98 p95_99
p5=p05_98 p05_99
q1=p25_98 p25_99
q3=p75_98 p75_99
median=med_98 med_99;
run;
proc transpose out=tabtrans;
run;