libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmc 'D:\PM NAAQS\summer04\coarse';

data pmc; set sp.Pmc_raw_dayagg_1284; in=1;
proc sort; by site;
data all; merge pmc sp.meta; by site;
if in=1;
run;
proc sort; by pmreg pmregdesc;
proc corr noprint data=all outp=cvt;
by pmreg pmregdesc site;
var pmc pmt;
run;
data cvt2 (keep=site pmregdesc pmreg cvt);
set cvt;
if _type_='CORR';
if _name_='pmt';
cvt=pmc;

data c_v_f;
set all;
if pmc ne . and pmf ne .;
proc corr noprint data=c_v_f outp=cvf;
by pmreg pmregdesc site;
var pmc pmf;
data cvf2 (keep=site pmregdesc pmreg cvf);
set cvf;
if _type_='CORR';
if _name_='pmf';
cvf=pmc;
run;

data t_v_f;
set all;
if pmt ne . and pmf ne .;
proc corr noprint data=t_v_f outp=tvf;
by pmreg pmregdesc site;
var pmt pmf;
data tvf2 (keep=site pmregdesc pmreg tvf);
set tvf;
if _type_='CORR';
if _name_='pmf';
tvf=pmt;
run;

data mergcorr; merge cvt2 cvf2 tvf2; by pmreg pmregdesc site;
proc sort; by pmreg pmregdesc;

proc means noprint; by pmreg pmregdesc;
var cvf cvt tvf;
output out=correg mean=cvf cvt tvf;
run;
data correg2; set correg; drop _type_ _freq_; if pmreg ne 0;
run;

goptions reset=all dev=cgmflwa  gaccess = gsasfile htext=1.0;
filename gsasfile "d:\pm naaqs\summer04\pm corr.cgm";
axis1 label=none offset=(5) minor=none value=none c=black;
axis2 label=none order=(0 to 1 by .1) minor=none c=black;
symbol1 value=triangle color=black h=2;
symbol2 value=square color=black h=2;
symbol3 value=dot color=black h=2;

run;

proc gplot data=correg2;
plot cvf*pmreg=3  cvt*pmreg=1 tvf*pmreg=2 / overlay
vref=(.1 .2 .3 .4 .5 .6 .7 .8 .9)
/*href=(1.5 2.5 3.5 4.5 5.5 6.5)
lvref=3*/
haxis=axis1
vaxis=axis2;
run;
quit;