libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmf 'D:\PM NAAQS\summer04\coarse';
data a (keep= site st cou in dv_p98 dv_p99); * nvalid2001 nvalid2002 nvalid2003 n2001 n2002 n2003 sf2001q1-sf2001q4 sf2002q1-sf2002q4 sf2003q1-sf2003q4);
set staff.Peaks_0103c;
if numq_n11=12;
/*nvalid2001=sum(of nvalid2001q1-nvalid2001q4);
nvalid2002=sum(of nvalid2002q1-nvalid2002q4);
nvalid2003=sum(of nvalid2003q1-nvalid2003q4);
n2001=sum(of n2001q1-n2001q4);
n2002=sum(of n2002q1-n2002q4);
n2003=sum(of n2003q1-n2003q4);*/
st=substr(site,1,2);
cou=substr(site,3,3);
in=1;
run;
data b (keep=site zdate v flag flagq year); set y.Pm25d12jul04colo;
if meth in (116 117 118 119 120 123 142 143 144 145);
if f1 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag=f1;
else if  f2 in ('A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'U') then flag=f2;
if fipstate(st) in ('NH' 'VT' 'CT' 'RI' 'MA' 'NY' 'NJ' 'PA' 'MD' 'DE') and (zdate ge
mdy(7,6,2002) and zdate le mdy(7,9,2002)) then flagq='E';
proc sort; by site;
data c; merge a b; by site;
if in=1;
run;

proc sql; 
create table qsites as select distinct site,count(*) as siteqct from c where flagq ne ' ' group by site;;
data d; merge c qsites; by site;
if siteqct ne .;
run;

proc sql;
create table s as select distinct site,zdate,v,flag,flagq from c where flagq ne ' '  order by v;
quit;
data lev1 (keep=site zdate v lev flag) lev2 (keep= site v lev) lev3 (keep=site v lev); set d;

if flagq =' ' then do; lev=1; output lev1; end;
if flagq ne ' ' then do; lev=2; output lev2; end;
if flagq ne ' ' and flag ne ' ' then do; lev=3; output lev3; end;
run;
data alllev; set lev1 lev2 lev3;
format v 5.1;

proc univariate noprint data=alllev;
by lev;
var v;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
run;
/*
data a; set uniout;
DO I=1 TO 10;
val=pct95; output;
val=pct05; output;
END;
do i=1 to 26;
val=pct25; output;
val=pct75; output;
val=median; output;
END;
VAL=MIN; OUTPUT;
VAL=MAX; OUTPUT;
run;*/

GOPTIONS reset=all dev=gif
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
symbol i=box05t bwidth=12 v=none;
axis1 label=none offset=(15) minor=none value=none;
axis2 label=none order=(0 to 120 by 10) c=black;
run;

filename gsasfile "D:\PM NAAQS\summer04\box_qevents_uni.gif";

proc gplot data=alllev;
plot v * lev /
vref=(10 20 30 40 50 60 70 80 90 100 110)
lvref=3
haxis=axis1
vaxis=axis2;
run;
quit;

proc sort data=d; by descending v;
run;


data alldat; set d;
proc sort; by site year;
run;
proc sql; create table ycts as select distinct site,year,count(*) as ct from alldat group by site,year;
quit;
data alldat2; merge alldat ycts; by site year;
q=qtr(zdate);
run;
proc sql; create table qtab as select distinct site,year,q,mean(v) as qmean from alldat2 group by site,year,q;
create table stabreg as select distinct site,round(mean(qmean),.1) as pmfmean,count(*) as check12 from qtab group by site;
quit;

proc sort data=alldat2; by site year descending v;
data pmf98 (keep=site year pmf98 nc98 ct) pmf99 (keep=site  year pmf99 nc99 ct);
set alldat2;
by site year descending v;
/*if year=2001 then valct=nvalid2001;
else if year=2002 then valct=nvalid2002;
else if year=2003 then valct=nvalid2003;*/

if first.year then do; i=0; nc98=0; nc99=0; end;
nc98=ct-int(.98*ct);
nc99=ct-int(.99*ct);
i+1;
if i=nc98 then do; 
pmf98=v;
output pmf98;
end;
if i=nc99 then do; 
pmf99=v;
output pmf99;
end;
run;
data both; set pmf98 pmf99;
run;
proc sort data=both; by site;
proc means noprint;
by site;
var pmf98 pmf99;
output out=tab mean= n=n;
run;
data tab2reg; set tab;
pmf98=round(pmf98,1);
pmf99=round(pmf99,1);
run;


data alldat3; set alldat2;
if flagq ne ' ' then v=.;
q=qtr(zdate);
run;
proc sql; create table qtab as select distinct site,year,q,mean(v) as qmean from alldat3 group by site,year,q;
create table stabq as select distinct site,round(mean(qmean),.1) as qpmfmean,count(*) as check12 from qtab group by site;
quit;
proc sort data=alldat3; by site year descending v;
data pmf98 (keep=site year qpmf98 nc98  ct) pmf99 (keep=site  year qpmf99 nc99 ct);
set alldat3;
by site year descending v;
/*if year=2001 then valct=nvalid2001;
else if year=2002 then valct=nvalid2002;
else if year=2003 then valct=nvalid2003;*/
if first.year then do; i=0; nc98=0; nc99=0; end;
nc98=ct-int(.98*ct);
nc99=ct-int(.99*ct);
i+1;
if i=nc98 then do; 
qpmf98=v;
output pmf98;
end;
if i=nc99 then do; 
qpmf99=v;
output pmf99;
end;
run;
data both; set pmf98 pmf99;
run;
proc sort data=both; by site;
proc means noprint;
by site;
var qpmf98 qpmf99;
output out=tab mean= n=n;
run;
data tab2q; set tab;
qpmf98=round(qpmf98,1);
qpmf99=round(qpmf99,1);
run;

data tab; merge tab2reg tab2q stabreg stabq; by site;
diff98=pmf98-qpmf98;
diff99=pmf99-qpmf99;
diffmean=pmfmean-qpmfmean;
lev=1;
run;

data tab2; set tab;
lev=1; val=diffmean; output;
lev=2; val=diff98; output;
lev=3; val=diff99; output;
proc sort; by lev;
proc univariate noprint data=tab2;
by lev;
var val;
output out=uniout min=MIN p5=PCT05 q1=PCT25 median=MEDIAN q3=PCT75
p95=PCT95 max=MAX mean=mmean n=n;
run;
proc transpose out=tranny;
run;


GOPTIONS reset=all dev=gif
GACCESS = GSASFILE ROTATE = LANDSCAPE colors=(black);
symbol i=box05t bwidth=75 v=none;
axis1 label=none offset=(15) minor=none value=none;
axis2 label=none order=(-1 to 16 by 1) c=black;
run;

filename gsasfile "D:\PM NAAQS\summer04\box_qevents_uni.gif";

proc gplot data=tab;
plot diff99 * lev /
/*vref=(0 .1 .2 .3 .4)
lvref=3*/
haxis=axis1
vaxis=axis2;
run;
quit;


proc sql; create table o15 as select distinct count(*) as num15 from tab where pmfmean gt 15;
create table o15b as select distinct count(*) as num15cross from tab where pmfmean gt 15 and qpmfmean le 15;
proc sql; create table o14 as select distinct count(*) as num14 from tab where pmfmean gt 14;
create table o14b as select distinct count(*) as num14cross from tab where pmfmean gt 14 and qpmfmean le 14;
proc sql; create table o13 as select distinct count(*) as num13 from tab where pmfmean gt 13;
create table o13b as select distinct count(*) as num13cross from tab where pmfmean gt 13 and qpmfmean le 13;
proc sql; create table o12 as select distinct count(*) as num12 from tab where pmfmean gt 12;
create table o12b as select distinct count(*) as num12cross from tab where pmfmean gt 12 and qpmfmean le 12;

data mean; merge o15 o15b o14 o14b o13 o13b o12 o12b; run;


proc sql; create table o65 as select distinct count(*) as num65 from tab where pmf98 gt 65;
create table o65b as select distinct count(*) as num65cross from tab where pmf98 gt 65 and qpmf98 le 65;
proc sql; create table o60 as select distinct count(*) as num60 from tab where pmf98 gt 60;
create table o60b as select distinct count(*) as num60cross from tab where pmf98 gt 60 and qpmf98 le 60;
proc sql; create table o55 as select distinct count(*) as num55 from tab where pmf98 gt 55;
create table o55b as select distinct count(*) as num55cross from tab where pmf98 gt 55 and qpmf98 le 55;
proc sql; create table o50 as select distinct count(*) as num50 from tab where pmf98 gt 50;
create table o50b as select distinct count(*) as num50cross from tab where pmf98 gt 50 and qpmf98 le 50;
proc sql; create table o45 as select distinct count(*) as num45 from tab where pmf98 gt 45;
create table o45b as select distinct count(*) as num45cross from tab where pmf98 gt 45 and qpmf98 le 45;
proc sql; create table o40 as select distinct count(*) as num40 from tab where pmf98 gt 40;
create table o40b as select distinct count(*) as num40cross from tab where pmf98 gt 40 and qpmf98 le 40;

data p98; merge o65 o65b  o60 o60b o55 o55b o50 o50b o45 o45b o40 o40b; run;


proc sql; create table o65 as select distinct count(*) as num65 from tab where pmf99 gt 65;
create table o65b as select distinct count(*) as num65cross from tab where pmf99 gt 65 and qpmf99 le 65;
proc sql; create table o60 as select distinct count(*) as num60 from tab where pmf99 gt 60;
create table o60b as select distinct count(*) as num60cross from tab where pmf99 gt 60 and qpmf99 le 60;
proc sql; create table o55 as select distinct count(*) as num55 from tab where pmf99 gt 55;
create table o55b as select distinct count(*) as num55cross from tab where pmf99 gt 55 and qpmf99 le 55;
proc sql; create table o50 as select distinct count(*) as num50 from tab where pmf99 gt 50;
create table o50b as select distinct count(*) as num50cross from tab where pmf99 gt 50 and qpmf99 le 50;
proc sql; create table o45 as select distinct count(*) as num45 from tab where pmf99 gt 45;
create table o45b as select distinct count(*) as num45cross from tab where pmf99 gt 45 and qpmf99 le 45;
proc sql; create table o40 as select distinct count(*) as num40 from tab where pmf99 gt 40;
create table o40b as select distinct count(*) as num40cross from tab where pmf99 gt 40 and qpmf99 le 40;

data p99; merge o65 o65b  o60 o60b o55 o55b o50 o50b o45 o45b o40 o40b; run;