libname staff 'D:\PM NAAQS\summer04';

%macro rawdata(lib,parm,intrvl,styear,endyear,flag,vname,userid,userpasswd);
%if &intrvl eq 1 %then %let hd=h;
%else %let hd=d;
%let rdsn=&lib..rdd&parm.d&styear&endyear&hd&sysdate;
%let sd=01-JAN-&styear;
%let ed=31-DEC-&endyear;
%let fname=&lib..p&parm;
run;
%put ****&hd****;
libname aqs oracle user=&userid pw=&userpasswd path='aqsprod';
* change v_production_raw_data to current_data;
proc sql;
     connect to oracle (user=&userid password=&userpasswd path="aqsprod" buffsize=100);
     create table temp as
     select * from connection to oracle (
select  sites.cc_cn_stt_state_code||sites.cc_cn_county_code||sites.site_id as site,
        monitors.poc as poc,monitors.mo_id as mo_id,sites.si_id as si_id,
        current_data.sampling_begin_datetime as datetime, protocols.un_unit as units,
        protocols.sm_methodology_code as method,
        sites.site_latitude as latitude,
        sites.site_longitude as longitude,
        sites.cc_ci_city_code as city,
        sites.ls_location_setting as loc,
%if %upcase(&flag) eq Y %then  %do;
        qualifier_details.qu_qualifier_code as flag,
        current_data.epa_concurrence_ind as concurr,
%end;
        current_data.std_sample_value as &vname
        from    monitors monitors,
        monitor_protocols monitor_protocols,
        protocols protocols,
%if %upcase(&flag) eq Y %then %do;
        qualifier_details qualifier_details,
%end;
        current_data current_data,
        sites sites
where   monitors.mo_id = monitor_protocols.mo_mo_id and
        protocols.pro_id = monitor_protocols.pro_pro_id and
        monitor_protocols.mo_mo_id = current_data.mp_mo_mo_id and
        monitor_protocols.mp_id = current_data.mp_mp_id and
%if %upcase(&flag) eq Y %then %do;
        current_data.rd_id = qualifier_details.rd_rd_id(+) and
%end;
        sites.si_id = monitors.si_si_id and
        sites.cc_cn_stt_state_code <> 'CC' and
        sites.cc_cn_stt_state_code <> '80' and
        protocols.sd_duration_code = %unquote(%str(%'&intrvl%')) and
        monitors.pa_parameter_code = %unquote(%str(%'&parm%')) and
        upper(current_data.status_ind) = upper('p') and
        current_data.sampling_begin_datetime >= %unquote(%str(%'&sd%')) and
        current_data.sampling_begin_datetime <= %unquote(%str(%'&ed%'))
order by 1, 2, 3
);
%put &sqlxrc; *debug sql;
%put &sqlxmsg; *debug sql;
disconnect from oracle;
quit;
proc sort data=temp; by site poc datetime;
data &lib..P&parm&hd._0103 (keep= site si_id st cou poc sdate value units f1-f10 mo_id q method
sample_start_hour units concurr);
length f1 $2. f2-f10 $1. flag $2.;
retain n f1-f10;
set temp; by site poc datetime;
sdate=datepart(datetime);
sample_start_hour=hour(datetime);
st=substr(site,1,2);
cou=substr(site,3,3);
array f(10) f1-f10;
format sdate mmddyy10.;
if first.datetime then do;
n=0;
f1=' '; f2=' '; f3=' '; f4=' '; f5=' '; f6=' '; f7=' '; f8=' '; f9=' '; f10=' ';
end;
n+1;
do i=1 to 10;
if n=i then f(i)=flag;
if i=10 then do;
q=qtr(sdate);
parm=&parm;
if last.datetime then output;
end;
end;
run;
%mend;
libname pmc 'D:\PM NAAQS\summer04\coarse';
%rawdata(pmc,81102,1,2001,2003,y,value,sme,elialexkris5);
