libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmc 'D:\PM NAAQS\summer04\coarse';
data a (keep= site st cou in dv_mean);
set staff.Peaks_0103c;
if site in ('180890022' '180970066' '180970043' '170311016' '171190023' '170990007'  
'440070020' '481410053' '291250001') then delete;
if numq_n11=12;
st=substr(site,1,2);
cou=substr(site,3,3);
data ref;
length area  $75.;
set r.cbsa_reference; 
if csa  ne ' ' then area='CSA_'||trim(csa_name);
else if cbsa ne ' ' then area='CBSA_'||trim(cbsa_name);
else area='STCOU_'||trim(fipstate(st))||'_'||trim(county_name);
*if csa in ('348') then delete;
*if cbsa='20940';
*IF SUBSTR(area,1,6) = 'CSA_As';
run;
proc sql; create table c as select distinct * from  a, ref where a.st=ref.st and a.cou=ref.cou; quit;
proc sql; create table left as select distinct *,count(*) as ct from c 
group by area having ct ge 2 order by area,site;quit;
proc sql; create table simp as select * from left a, sp.tractdata b where a.site=b.site;
quit;
data staff.simp_spatial; set simp; 
avg_ed=
(((pop_m1+pop_f1)*1)+((pop_m2+pop_f2)*2)+
((pop_m3+pop_f3)*3)+((pop_m4+pop_f4)*4)+ 
((pop_m5+pop_f5)*5)+((pop_m6+pop_f6)*6)+
((pop_m7+pop_f7)*7)+((pop_m8+pop_f8)*8)+
((pop_m9+pop_f9)*9)+((pop_m10+pop_f10)*10)+
((pop_m11+pop_f11)*11)+((pop_m12+pop_f12)*12)+
((pop_m13+pop_f13)*13)+((pop_m14+pop_f14)*14)+ 
((pop_m15+pop_f15)*15)+((pop_m16+pop_f16)*16))/pop_mf;
perhiskool=(pop_m9+pop_f9+pop_m10+pop_f10+
pop_m11+pop_f11+pop_m12+pop_f12+pop_m13+pop_f13+pop_m14+pop_f14+
pop_m15+pop_f15+pop_m16+pop_f16)/pop_mf;
minor=sum(of pop_ind, pop_asian, pop_hi, pop_other, pop_black, pop_mixed);
percent_minority=minor/pop2000;
run;
proc sort data= staff.simp_spatial; by area site; run;
proc sort data=sp.sa_sites_current15; by area site;
data only; merge staff.simp_spatial sp.sa_sites_current15; by area site;
*if in=1;
run;

*education;
proc corr data=only noprint out=corrout;
by area;
var dv_mean avg_ed;
*var dv_mean perhiskool;
run;
data corra (keep=area corr_ed) corrb (keep=area numsites);
set corrout;
if _type_='N' then do;
numsites=dv_mean;
if numsites gt 2 then numsites=3;
output corrb;
end;
if _type_='CORR' and _name_='dv_mean' then do;
corr_ed=avg_ed;
*corr_ed=perhiskool;
output corra;
end;
data corr;merge corra corrb; by area;
if corr_ed ne .;
run;
proc sql;create table a as select distinct numsites,count(*) as numareas_negcorr,
avg(corr_ed) as avg_corr_ed from corr where corr_ed lt 0
group by numsites;
create table b as select distinct numsites,count(*) as numareas_tot from corr
group by numsites;
quit;
proc sort data=corr; by numsites;
proc univariate noprint data=corr;
where numsites=3;
where corr_ed lt 0;
by numsites;
var corr_ed;
output out=uni mean=mean median=median;
run;
data ced; merge a b uni; by numsites;
run;

*education2;
proc corr data=only noprint out=corrout;
by area;
var dv_mean perhiskool;
run;
data corra (keep=area corr_ed2) corrb (keep=area numsites);
set corrout;
if _type_='N' then do;
numsites=dv_mean;
if numsites gt 2 then numsites=3;
output corrb;
end;
if _type_='CORR' and _name_='dv_mean' then do;
corr_ed2=perhiskool;
output corra;
end;
data corr;merge corra corrb; by area;
if corr_ed2 ne .;
run;
proc sql;create table a as select distinct numsites,count(*) as numareas_negcorr,
avg(corr_ed2) as avg_corr_ed2 from corr where corr_ed2 lt 0
group by numsites;
create table b as select distinct numsites,count(*) as numareas_tot from corr
group by numsites;
quit;
proc sort data=corr; by numsites;
proc univariate noprint data=corr;
where numsites=3;
where corr_ed2 lt 0;
by numsites;
var corr_ed2;
output out=uni mean=mean median=median;
run;
data ced2; merge a b uni; by numsites;
run;

*per cap income;
proc corr data=only noprint out=corrout;
by area;
var dv_mean per_cap_income;
run;
data corra (keep=area corr_pci) corrb (keep=area numsites);
set corrout;
if _type_='N' then do;
numsites=dv_mean;
if numsites gt 2 then numsites=3;
output corrb;
end;
if _type_='CORR' and _name_='dv_mean' then do;
corr_pci=per_cap_income;
output corra;
end;
data corr;merge corra corrb; by area;
if corr_pci ne .;
run;

proc sql;create table a as select distinct numsites,count(*) as numareas_negcorr,
avg(corr_pci) as avg_corr_pci from corr where corr_pci lt 0
group by numsites;
create table b as select distinct numsites,count(*) as numareas_tot from corr
group by numsites;
quit;
proc sort data=corr; by numsites;
proc univariate noprint data=corr;
where numsites=3;
where corr_pci lt 0;
by numsites;
var corr_pci;
output out=uni mean=mean median=median;
run;
data cpci; merge a b uni; by numsites;
run;


*hh income;
proc corr data=only noprint out=corrout;
by area;
var dv_mean med_hh_income;
run;
data corra (keep=area corr_mhhi) corrb (keep=area numsites);
set corrout;
if _type_='N' then do;
numsites=dv_mean;
if numsites gt 2 then numsites=3;
output corrb;
end;
if _type_='CORR' and _name_='dv_mean' then do;
corr_mhhi=med_hh_income;
output corra;
end;
data corr;merge corra corrb; by area;
if corr_mhhi ne .;
run;
proc sql;create table a as select distinct numsites,count(*) as numareas_negcorr,
avg(corr_mhhi) as avg_corr_mhhi from corr where corr_mhhi lt 0
group by numsites;
create table b as select distinct numsites,count(*) as numareas_tot from corr
group by numsites;
quit;
proc sort data=corr; by numsites;
proc univariate noprint data=corr;
where numsites=3;
where corr_mhhi lt 0;
by numsites;
var corr_mhhi;
output out=uni mean=mean median=median;
run;
data cmhhi; merge a b uni; by numsites;
run;


*family income;
proc corr data=only noprint out=corrout;
by area;
var dv_mean med_fam_income;
run;
data corra (keep=area corr_mfi) corrb (keep=area numsites);
set corrout;
if _type_='N' then do;
numsites=dv_mean;
if numsites gt 2 then numsites=3;
output corrb;
end;
if _type_='CORR' and _name_='dv_mean' then do;
corr_mfi=med_fam_income;
output corra;
end;
data corr;merge corra corrb; by area;
if corr_mfi ne .;
run;
proc sql;create table a as select distinct numsites,count(*) as numareas_negcorr,
avg(corr_mfi) as avg_corr_mfi from corr where corr_mfi lt 0
group by numsites;
create table b as select distinct numsites,count(*) as numareas_tot from corr
group by numsites;
quit;
proc sort data=corr; by numsites;
proc univariate noprint data=corr;
where numsites=3;
where corr_mfi lt 0;
by numsites;
var corr_mfi;
output out=uni mean=mean median=median;
run;
data cfi; merge uni a b; by numsites;
run;


*percent minority;
proc corr data=only noprint out=corrout;
by area;
var dv_mean percent_minority;
run;
data corra (keep=area corr_pminor) corrb (keep=area numsites);
set corrout;
if _type_='N' then do;
numsites=dv_mean;
if numsites gt 2 then numsites=3;
output corrb;
end;
if _type_='CORR' and _name_='dv_mean' then do;
corr_pminor=percent_minority;
output corra;
end;
data corr;merge corra corrb; by area;
if corr_pminor ne .;
run;
proc sql;create table a as select distinct numsites,count(*) as numareas_poscorr,
avg(corr_pminor) as avg_corr_pminor from corr where corr_pminor gt 0
group by numsites;
create table b as select distinct numsites,count(*) as numareas_tot from corr
group by numsites;
quit;
proc sort data=corr; by numsites;
proc univariate noprint data=corr;
where numsites=3;
where corr_pminor gt 0;
by numsites;
var corr_pminor;
output out=uni mean=mean median=median;
run;
data cpm; merge uni a b; by numsites;
run;

data all; set cpm cfi cmhhi cpci ced CED2;
where numsites ne 1;
run;

proc sql; create table tract as select distinct area,stcoutract,count(*) as ct from only group by area,stcoutract 
having ct gt 1; quit; 
proc sort data=only; by area stcoutract descending dv_mean;
data only2; set only; by area stcoutract descending dv_mean; if first.stcoutract; run;


*calculate area correlation;
data asites (keep=area site1 dv); set left; dv=dv_mean; site1=site;
data asitesb (keep=area site2 dv2); set asites; 
dv2=dv;
site2=site1;
proc sql; create table pairs as select distinct * from asites a, asitesb b where a.area=b.area
and a.site1 gt b.site2;* and (dv/dv2 ge .8 and dv/dv2 le 1.2);
quit;
data left; set pairs;
%macro doit;
data first; set pairs;
run;
data cumcorr;
run;
%do i=1 %to 2227;
data first;
set first;
if _n_=1 then do;
call symput('keeparea',trim(area));
call symput('site1',trim(site1));
call symput('site2',trim(site2));
delete;
end;
run;
%put ***area=&keeparea***;
%put ***site1=&site1***;
%put ***site2=&site2***;
run;
proc sql; create table raw1 as select distinct *  from y.Pm25d12jul04colo where
site ="&site1";
quit;
data raw1b (keep=site1 v1 zdate); set raw1; v1=v;site1=site; 
proc sort; by zdate;
proc sql; create table raw2 as select distinct *  from y.Pm25d12jul04colo where
site="&site2";
data raw2b (keep=site2 v2 zdate); set raw2; v2=v; site2=site;
proc sort; by zdate;
quit;
data rawboth; merge raw1b raw2b; by zdate;
if v1 ne . and v2 ne .;
q=qtr(zdate);
area="&keeparea";
proc sort; by area site1 site2;
proc corr noprint out=corrout;
by area site1 site2;
var v1 v2;
run;
data corrout2 (keep=area site1 site2 corr); set corrout;
if _type_='CORR';
if _name_='v1';
corr=v2;
run;

proc sort data=rawboth; by area site1 site2 q;
proc corr noprint out=corrout;
by area site1 site2 q;
var v1 v2;
run;
data corrout2b (keep=area site1 site2 qid qcorr); set corrout;
if _type_='CORR';
if _name_='v1';
qcorr=v2;
qid='q'||compress(put(q,1.0));
run;
proc transpose out=tran;
by area site1 site2;
var qcorr;
id qid;

data corrout3; merge corrout2 tran; by area site1 site2;


data cumcorr; set cumcorr corrout3;
%end;
%mend doit;
run;
%doit;
run;
proc univariate noprint data=cumcorr;
by area;
var corr;
output out=tabbyarea mean=mean median=median n=n min=min max=max;
run;
title 'stats for area average corr - 20%DV tolerance';
proc univariate  data=tabbyarea;
var mean;
output out=taball mean=mean median=median n=n q1=q1 q3=q3 p95=p95 p5=p05 min=min max=max;
run;
title 'stats for site corr  20%DV tolerance';
proc univariate  data=cumcorr;
var corr;
output out=taball mean=mean median=median n=n q1=q1 q3=q3 p95=p95 p5=p05 min=min max=max;
run;


data sp.cumcorr_a_v_q; set cumcorr; run;
data a; set sp.cumcorr_a_v_q;;
mincorr=min(of q1-q4);
diff=abs(corr-mincorr);
pdiff=diff/corr;
run;
proc univariate;
var diff;
run;
proc sort;by diff;
run;

proc sql; select count(*) from a where corr lt mincorr; quit;
proc sql; select count(*) from a where corr gt q1 and corr gt q2 and corr gt q3 and corr gt q4; quit;
data a (keep= site st cou in mean_2001 mean_2002 mean_2003);
set staff.Peaks_0103c;
if site in ('180890022' '180970066' '180970043' '170311016' '171190023' '170990007'  
'440070020' '481410053' '291250001') then delete;
if numq_n11=12;
st=substr(site,1,2);
cou=substr(site,3,3);
data ref;
length area  $75.;
set r.cbsa_reference; 
if csa  ne ' ' then area='CSA_'||trim(csa_name);
else if cbsa ne ' ' then area='CBSA_'||trim(cbsa_name);
else area='STCOU_'||trim(fipstate(st))||'_'||trim(county_name);
if csa='348' then delete;
*if cbsa='20940';
*IF SUBSTR(area,1,6) = 'CSA_As';
run;
proc sql; create table c as select distinct * from  a, ref where a.st=ref.st and a.cou=ref.cou; quit;
proc sort;by area;
proc sql; create table ct as select distinct area,count(*) as ct from c group by area;
data d; merge c ct; by area;
if ct ge 2;
proc sort; by area;
proc means noprint;
by area;
var mean_2001 mean_2002 mean_2003;
output out=tab mean=smean_2001 smean_2002 smean_2003;
data e; merge d tab; by area;
if ct ge 2;
run;
data it (keep=diff); set e;
array spat(3) smean_2001 smean_2002 smean_2003;
array mn(3) mean_2001 mean_2002 mean_2003;
do i=1 to 3;
diff=abs(spat(i)/mn(i)-1)*100;
output;
end;
run;
proc univariate noprint;
output out=tab max=max min=min p95=p95 p90=p90 p5=p05 q1=p25 q3=p75 mean=mean median=median n=n;;
run;

