libname pmr 'F:\aqtag\PMBooklet\Data';
libname staff 'd:\pm naaqs\summer04';
libname sp 'F:\aqtag\pm naaqs sp\data';
libname pmc 'D:\PM NAAQS\summer04\coarse';
%let thresh=14.0;
%let corrthresh=.60;
%put **&thresh**;
%put **&corrthresh**;
run;
*get complete sites;
data a (keep= site st cou in dv_mean dv_mean2 mean_2001 mean_2002 mean_2003 
mean2001q1-mean2001q4 mean2002q1-mean2002q4 mean2003q1-mean2003q4
n2001q1-n2001q4 n2002q1-n2002q4 n2003q1-n2003q4
p2001q1-p2001q4 p2002q1-p2002q4 p2003q1-p2003q4 p75__2001 p75__2002 p75__2003);
set staff.Peaks_0103c;
dv_mean2=dv_mean;
if p2001q1 ge .75 and p2001q2 ge .75 and p2001q3 ge .75 and p2001q4 ge .75 then p75__2001=1;
if p2002q1 ge .75 and p2002q2 ge .75 and p2002q3 ge .75 and p2002q4 ge .75 then p75__2002=1;
if p2003q1 ge .75 and p2003q2 ge .75 and p2003q3 ge .75 and p2003q4 ge .75 then p75__2003=1;
if site in ('180890022' '180970066' '180970043' '170311016' '171190023' '170990007'  
'440070020' '481410053' '291250001') then delete;
if numq_n11=12;
st=substr(site,1,2);
cou=substr(site,3,3);
*p75__2001=1;
*p75__2002=1;
*p75__2003=1;
if (dv_mean2 le &thresh) and ((p75__2001 ne 1 and mean_2001 le &thresh) or (p75__2002 ne 1 and mean_2001 le &thresh)
or (p75__2003 ne 1 and mean_2003 le &thresh)) then dv_mean2=.;

*if site in ('010731005' '060130002' '060730001' '220470009' '132150001' '482010026' 
'211510003' '051450001') then delete;
*if site in ('420770004' '271377001' '060251003' '250130008' '250250042' '482010026' '311770002')
then delete;
in=1;
run;

proc sort; by site;

*get raw data for complete sites;
data b; set y.Pm25d12jul04colo;
if meth in (116 117 118 119 120 123 142 143 144 145);
proc sort; by site;
run;
data raw (keep=site v zdate); merge a (keep=site in) b; by site;
if in=1;
run;

*group sites by area and get areas with 3 or more complete sites;
data ref;
length area  $75.;
set r.cbsa_reference; 
if csa  ne ' ' then area='CSA_'||trim(csa_name);
else if cbsa ne ' ' then area='CBSA_'||trim(cbsa_name);
else area='STCOU_'||trim(fipstate(st))||'_'||trim(county_name);
*if csa in ('348') then delete; /*122*/
*if cbsa='20940';
*IF SUBSTR(area,1,5) = 'CSA_A';
run;
proc sql; create table c as select distinct * from  a, ref where a.st=ref.st and a.cou=ref.cou; quit;
proc sql; create table left as select distinct area,count(*) as ct,max(dv_mean2) as maxdv from c 
group by area having ct ge 2;quit;
%let numareas=&sqlobs;
run;
%put ****&numareas***;
run;
data cumsite; run;
data cumarea; run;
data corrsss; run;


%macro allareas;
%do i=1 %to &numareas;

data left; set left;
if _n_=1 then do;
call symput('keeparea',trim(area));
delete;
end;
run;
%put ***&keeparea***;
run;
quit;

proc sql; create table areasites as select distinct * from c where area="&keeparea"; quit;
/*%put ***&sqlobs***;
%let numsites=&sqlobs;
run;
%put ***&numsites***;
run;
*/

*calculate correlation;
data areasites2; set areasites;
site2=site; drop site;
dvs2=dv_mean; drop dv_mean;
proc sql; create table both as select distinct site,site2,dv_mean as dvs1,dvs2 from areasites,areasites2
where site gt site2; quit;
quit;
data raw2; set raw; site2=site; v2=v;
drop site v;
run;
proc sql; create table raw4 as select distinct both.site,both.site2,dvs1,dvs2,v,v2,raw.zdate from both, raw, raw2 where
both.site=raw.site and both.site2=raw2.site2 and raw.zdate=raw2.zdate;
data raw4; set raw4;
q=qtr(zdate);
q=1;
run;
proc sort; by site site2 dvs1 dvs2 q;
proc corr noprint out=corrout;
by site site2 dvs1 dvs2 q;
var v v2;
run;
data corrout2 (keep=site site2 dvs1 dvs2 q corr); set corrout;
if _type_='CORR';
if _name_='V';
corr=v2;
run;
proc sql; create table corrout2 as select distinct site, site2, dvs1,dvs2,min(corr) as corr 
from corrout2 group by site,site2; quit;
data checkit (keep=site delet);
set corrout2;
delet=1;
if corr lt &corrthresh then do;
 if dvs2 gt dvs1 then do; output; end;
 else if dvs1 gt dvs2 then do; site=site2; output; end;
else do; output; site=site2; output; end;
end;
else do; end;
run;
proc sort; by site;
proc sort data=areasites; by site;
data areasites; merge checkit areasites; by site; if delet=1 then delete;
proc sql; create table nada as select distinct site from areasites;
%put ***&sqlobs***;
%let numsites=&sqlobs;
%put ***&numsites***;
quit;
*calculate spatial annual mean and check site diff;
*drop lowest dv site if diff gt 20/10 and try again;
proc sort data=areasites; by area descending dv_mean;
data sites2; set areasites; by area descending dv_mean;
if site='470090011' then delete;
num+1;
sitenum='mn_site'||compress(put(num,2.0));
sitenum2='p75_site'||compress(put(num,2.0));
if last.area then last=1;
run;
proc transpose data=sites2 out=trannya;
by area;
var mean_2001 mean_2002 mean_2003;
id sitenum;
run;
data trannya; set trannya;
y=substr(_name_,6,4);
proc sort; by y;

proc transpose data=sites2 out=trannyb;
by area;
var p75__2001 p75__2002 p75__2003;
id sitenum2;
run;
data trannyb; set trannyb;
y=substr(_name_,6,4);
proc sort; by y;
run;
%let numsitesb=&numsites;
%put ***&numsitesb***;
run;
data tranny; merge trannya trannyb; by y;

run;
data tranny01 (keep=area sumok01); set tranny;
array sitep75(&numsites) p75_site1-p75_site&numsites;
array sitemns(&numsites) mn_site1-mn_site&numsites;
array oks(&numsites) ok1-ok&numsites;
if y='2001';
oka=0;
j=&numsites;
do while (oka=0);
spatial01=0;
do i= 1 to j;spatial01=spatial01+sitemns(i)/j;end;
if round(spatial01,.1) le &thresh then do;
 do i = 1 to j;
 if sitep75(i) ne 1 then sitemns(i)=.;
 end;
spatial01=0;
spatial01=mean(of sitemns{*});
end;
do i = 1 to j;
oks(i)=0;
check=sitemns(i)/spatial01;
if (check lt 1.20 and check gt .8) or check=. then oks(i)=1; 
*if (check lt 1.10 and check gt .9) or check=. then oks(i)=1; 
end;
sumok01=0;
do i= 1 to j;sumok01=sumok01+oks(i);end;
if sumok01 eq j then oka=1;
else j=j-1;
end;
run;

data tranny02 (keep=area sumok02); set tranny;
array sitep75(&numsites) p75_site1-p75_site&numsites;
array sitemns(&numsites) mn_site1-mn_site&numsites;
array oks(&numsites) ok1-ok&numsites;
if y='2002';
oka=0;
j=&numsites;
do while (oka=0);
spatial02=0;
do i= 1 to j;spatial02=spatial02+sitemns(i)/j;end;
if round(spatial02,.1) le &thresh then do;
do i = 1 to j;
if sitep75(i) ne 1 then sitemns(i)=.;
end;
spatial02=0;
spatial02=mean(of sitemns{*});
end;
do i = 1 to j;
oks(i)=0;
check=sitemns(i)/spatial02;
if (check lt 1.20 and check gt .8) or check=. then oks(i)=1;
*if (check lt 1.10 and check gt .9) or check=. then oks(i)=1;  
end;
sumok02=0;
do i= 1 to j;sumok02=sumok02+oks(i);end;
if sumok02 eq j then oka=1;
else j=j-1;
end;
run;

data tranny03 (keep=area sumok03); set tranny;
array sitep75(&numsites) p75_site1-p75_site&numsites;
array sitemns(&numsites) mn_site1-mn_site&numsites;
array oks(&numsites) ok1-ok&numsites;
if y='2003';
oka=0;
j=&numsites;
do while (oka=0);
spatial03=0;
do i= 1 to j;spatial03=spatial03+sitemns(i)/j;end;
if round(spatial03,.1) le &thresh then do;
do i = 1 to j;
if sitep75(i) ne 1 then sitemns(i)=.;
end;
spatial03=0;
spatial03=mean(of sitemns{*});
end;
do i = 1 to j;
oks(i)=0;
check=sitemns(i)/spatial03;
if (check lt 1.20 and check gt .8) or check=. then oks(i)=1; 
*if (check lt 1.10 and check gt .9) or check=. then oks(i)=1; 
end;
sumok03=0;
do i= 1 to j;sumok03=sumok03+oks(i);end;
if sumok03 eq j then oka=1;
else j=j-1;
end;
run;


data tranall; merge tranny01 tranny02 tranny03;
minsites=min(of sumok01-sumok03);
run;

proc sql; create table it as select distinct * from tranall, sites2 where num le minsites;
proc sql; create table nextdv as select distinct a.area,dv_mean2 as nexthi_dv from tranall a,
sites2 b where a.area=b.area and num eq minsites+1;
quit;
run;

proc means noprint data=it;
var mean_2001 mean_2002 mean_2003;
output out=tab mean=smean01 smean02 smean03 max(dv_mean2)=reg_dv;

proc sql; create table it2 as select distinct * from it,tab; 
proc sort; by area;

data it2; 
set it2;
redo1=.; redo2=.; redo3=.;
if round(smean01,.1) lt 15.1 and p75__2001 =. then do; mean_2001=.; redo1=1; end;
if round(smean02,.1) lt 15.1 and p75__2002 =. then do; mean_2002=.; redo2=1; end;
if round(smean03,.1) lt 15.1 and p75__2003 =. then do; mean_2003=.; redo3=1; end;
if redo1=1 or redo2=1 or redo3=1 then do;
drop smean01 smean02 smean03;
%let redoo=1;
end;

%if &redoo=1 %then %do;
proc means noprint data=it2;
var mean_2001 mean_2002 mean_2003;
output out=tab mean=smean01 smean02 smean03 max(dv_mean2)=reg_dv;
proc sql; create table it2 as select distinct * from it2,tab; 
proc sort; by area;
%end;
run;


data it3 (keep=area reg_dv spatial_dv maxdif minsites);
retain maxdif;
set it2; by area;
if smean01=. or smean02=. or smean03=. then spatial_dv=.; 
else spatial_dv=round(mean(of smean01-smean03),.1);
array s(3) smean01-smean03;
array m(3) mean_2001-mean_2003;
do i=1 to 3;
dif=abs((m(i)/s(i))-1)*100;
if dif ge maxdif then maxdif=dif;
end;
if last.area then output;
run;
proc sql; create table gutsites as select distinct a.site, b.site as site2 from it2 a, it2 b
where a.site gt b.site;
proc sort; by site site2;

proc sql; create table mincorr as select distinct min(corr) as corr 
from gutsites a, corrout2 b where a.site = b.site and a.site2=b.site2;
proc sql; create table mincorr2 as select distinct site,site2,a.corr as mincorr from
mincorr a, corrout2 b where a.corr=b.corr;
quit;
data it4; merge mincorr2 it3 nextdv;
data cumarea; set cumarea it4;
data cumsite; set cumsite it2;
data corrsss; set corrsss corrout2; run;
%end;

%mend allareas;


run;
%allareas;
run;

proc sql; create table areasitesall as select distinct area,site,dv_mean from c order by area,
dv_mean descending ; quit;
data sp.cumarea;set cumarea;
data sp.cumsite; set cumsite;
run;

data cumarea2;* (keep=site site2 mincorr area);
length area $100.;
set cumarea;
if reg_dv ge 12;
*if nexthi_dv le &thresh;
if minsites ge 2;
if mincorr le .6 and minsites=2 then delete;
run;
data cumarea3; set cumarea2; corrsite2=site2; corrsite=site; drop site site2;
in=1; run;
proc sql; create table spatsites as select distinct * from cumarea3 a,areasitesall b
where a.area=b.area;
quit;

proc sql; create table sites as select distinct site from spatsites; quit;

proc sql; create table sp.cumsitemeta as select distinct * from spatsites a, sp.tractdata b
where a.site=b.site; quit;
proc sort; by area;
data dv (keep= area pop2000 sqmi pop00_sqmi white minor med_hh_income med_fam_income 
per_cap_income cap_income pop_mf pop_m0-pop_m16 pop_f0-pop_f16)
other (keep= area pop2000 sqmi pop00_sqmi white minor med_hh_income med_fam_income 
per_cap_income cap_income site pop_mf pop_m0-pop_m16 pop_f0-pop_f16);
set sp.cumsitemeta;
white=pop_white;
cap_income=per_cap_income*pop2000;
minor=sum(of pop_ind, pop_asian, pop_hi, pop_other, pop_black, pop_mixed);
if reg_dv=dv_mean then output dv;
else output other;
run;

proc means data=dv noprint;
by area;
output out=dvtab sum(sqmi pop2000 white minor cap_income pop_mf pop_m0-pop_m16 pop_f0-pop_f16)=
mean(med_hh_income med_fam_income)=dv_med_hh_income dv_med_fam_income;
run;

proc means data=other noprint;
by area;
output out=othertab sum(sqmi pop2000 white minor cap_income pop_mf pop_m0-pop_m16 pop_f0-pop_f16)=
mean(med_hh_income med_fam_income)=o_med_hh_income o_med_fam_income n=o_n;
run;

data dv2; set dvtab;
dv_pop=pop2000;
dv_sqmi=sqmi;
dv_per_cap_income=cap_income/pop2000;
dv_pminor=minor/pop2000;
dv_pwhite=white/pop2000;
dv_pop00_sqmi=pop2000/sqmi;
dv_avged=
(((pop_m1+pop_f1)*1)+((pop_m2+pop_f2)*2)+
((pop_m3+pop_f3)*3)+((pop_m4+pop_f4)*4)+ 
((pop_m5+pop_f5)*5)+((pop_m6+pop_f6)*6)+
((pop_m7+pop_f7)*7)+((pop_m8+pop_f8)*8)+
((pop_m9+pop_f9)*9)+((pop_m10+pop_f10)*10)+
((pop_m11+pop_f11)*11)+((pop_m12+pop_f12)*12)+
((pop_m13+pop_f13)*13)+((pop_m14+pop_f14)*14)+ 
((pop_m15+pop_f15)*15)+((pop_m16+pop_f16)*16))/pop_mf;
dv_perhiskool=(pop_m9+pop_f9+pop_m10+pop_f10+
pop_m11+pop_f11+pop_m12+pop_f12+pop_m13+pop_f13+pop_m14+pop_f14+
pop_m15+pop_f15+pop_m16+pop_f16)/pop_mf;
run;

data o2; set othertab;
o_pop=pop2000;
o_sqmi=sqmi;
o_per_cap_income=cap_income/pop2000;
o_pminor=minor/pop2000;
o_pwhite=white/pop2000;
o_pop00_sqmi=pop2000/sqmi;
o_avged=
(((pop_m1+pop_f1)*1)+((pop_m2+pop_f2)*2)+
((pop_m3+pop_f3)*3)+((pop_m4+pop_f4)*4)+ 
((pop_m5+pop_f5)*5)+((pop_m6+pop_f6)*6)+
((pop_m7+pop_f7)*7)+((pop_m8+pop_f8)*8)+
((pop_m9+pop_f9)*9)+((pop_m10+pop_f10)*10)+
((pop_m11+pop_f11)*11)+((pop_m12+pop_f12)*12)+
((pop_m13+pop_f13)*13)+((pop_m14+pop_f14)*14)+ 
((pop_m15+pop_f15)*15)+((pop_m16+pop_f16)*16))/pop_mf;
o_perhiskool=(pop_m9+pop_f9+pop_m10+pop_f10+
pop_m11+pop_f11+pop_m12+pop_f12+pop_m13+pop_f13+pop_m14+pop_f14+
pop_m15+pop_f15+pop_m16+pop_f16)/pop_mf;
run;


proc sql; create table areacou as select distinct r.st,r.cou,r.area from ref r, cumarea3 b where
r.area=b.area; quit;
proc sql; create table cou as select distinct * from areacou a, sp.countymeta2 b
where a.st=b.st and a.cou=b.cou;
data cous (keep= area pop2000 sqmi pop00_sqmi white minor med_hh_income med_fam_income 
per_cap_income cap_income pop_mf pop_m0-pop_m16 pop_f0-pop_f16);
set cou;
white=pop_white;
cap_income=per_cap_income*pop2000;
minor=sum(of pop_ind, pop_asian, pop_hi, pop_other, pop_black, pop_mixed);
run;

proc sort; by area;
proc means data=cous noprint;
by area;
output out=coutab sum(sqmi pop2000 white minor cap_income pop_mf pop_m0-pop_m16 pop_f0-pop_f16)=
mean(med_hh_income med_fam_income)=area_med_hh_income area_med_fam_income;
run;

data cous2; set coutab;
area_pop=pop2000;
area_sqmi=sqmi;
area_per_cap_income=cap_income/pop2000;
area_pminor=minor/pop2000;
area_pwhite=white/pop2000;
area_pop00_sqmi=pop2000/sqmi;
area_avged=
(((pop_m1+pop_f1)*1)+((pop_m2+pop_f2)*2)+
((pop_m3+pop_f3)*3)+((pop_m4+pop_f4)*4)+ 
((pop_m5+pop_f5)*5)+((pop_m6+pop_f6)*6)+
((pop_m7+pop_f7)*7)+((pop_m8+pop_f8)*8)+
((pop_m9+pop_f9)*9)+((pop_m10+pop_f10)*10)+
((pop_m11+pop_f11)*11)+((pop_m12+pop_f12)*12)+
((pop_m13+pop_f13)*13)+((pop_m14+pop_f14)*14)+ 
((pop_m15+pop_f15)*15)+((pop_m16+pop_f16)*16))/pop_mf;
areA_perhiskool=(pop_m9+pop_f9+pop_m10+pop_f10+
pop_m11+pop_f11+pop_m12+pop_f12+pop_m13+pop_f13+pop_m14+pop_f14+
pop_m15+pop_f15+pop_m16+pop_f16)/pop_mf;
run;

proc sql; create table low as select distinct area,min(dv_mean2) as min_dv,count(*) as 
check from cumsite group by area; quit;
proc sql; create table insites as select distinct site from cumsite;
data insites; set insites; inn=1;
data lefty; merge insites c (keep=area site dv_mean2); by site;
proc sql; create table nexthigh as select distinct area, max(dv_mean2) as lefthi2 from lefty where inn ne 1
group by area; quit;


proc sql; create table left as select distinct area,count(*) as ct,max(dv_mean2) as maxdv from c 
group by area having ct ge 2;quit;

*YYYYYYYYY;
data sp.cumareafinal_ad20std14_5; merge cumarea3 dv2 o2 cous2 left low nexthigh;
by area;
if in=1;
*if spatial_dv le &thresh;
if reg_dv gt &thresh;
*if lefthi le &thresh; 
run;


proc sql; create table rdv as select distinct area, b.mean_2001,b.mean_2002,b.mean_2003,b.site,a.mean_2001 as m01,a.mean_2002 as m02,
a.mean_2003 as m03,b.p75__2001,b.p75__2002,b.p75__2003,b.dv_mean,b.dv_mean2,
b.reg_dv,b.spatial_dv,b.smean01,b.smean02,b.smean03 from staff.Peaks_0103c a, 
sp.cumsitemeta b where a.site=b.site order by area,dv_mean descending; quit;

data outsites;
set rdv; by area descending dv_mean;  
if not first.area then area=' ';
output;
if last.area then do;
mean_2001=smean01; mean_2002=smean02; mean_2003=smean03; dv_mean=spatial_dv;
area='Spatial Average';
output;
end;
run;

data new.tdv0103 (keep=site poc dv_mean dv_p98 compnaaqs_annual compnaaqs_daily); set new.dv0103;
dv_mean=dv_0103;
run;

%let thresh=14.0;
%put ***&thresh***;
data cumareaa; 
set sp.Cumareafinal_ad20std14_5;
if substr(area,1,6)='CSA_At' then delete;
if spatial_dv ne .; 
*if minsites=ct; 
t='a';
diff_dv=reg_dv-spatial_dv;
diff_pminor=dv_pminor-o_pminor;
diff_pcapita=dv_per_cap_income-o_per_cap_income;
*if spatial_dv le &thresh;
if reg_dv gt &thresh;
*if spatial_dv lt lefthi;
run;
proc univariate noprint; 
by t;
var diff_dv diff_pminor diff_pcapita area_pop;
output out=uniouta min=min_1-min_3 a p5=pct05_1-pct05_3 a q1=pct25_1-pct25_3 a median=med_1-med_3 a
q3=pct75_1-pct75_3 a p95=pct95_1-pct95_3 a max=max_1-max_3 a mean=mn_1-mn_3 a n=n_1-n_3 a sum=a a a pop; 
run;

data cumareab; set cumareaa;
t='b';
if spatial_dv le &thresh  and reg_dv gt &thresh and nexthi_dv le &thresh;
proc univariate noprint; 
by t;
var diff_dv diff_pminor diff_pcapita area_pop;
output out=unioutb min=min_1-min_3 a p5=pct05_1-pct05_3 a q1=pct25_1-pct25_3 a median=med_1-med_3 a
q3=pct75_1-pct75_3 a p95=pct95_1-pct95_3 a max=max_1-max_3 a mean=mn_1-mn_3 a n=n_1-n_3 a sum=a a a pop; 
run;

data merg; set uniouta unioutb;
run;
proc transpose out=tranny;
by t;
run;




data cum; 
retain area ct minsites reg_dv spatial_dv min_dv maxdif mincorr 
dv_pop dv_pop00_sqmi dv_pminor dv_per_cap_income 
o_pop o_pop00_sqmi o_pminor o_per_cap_income
area_pop area_pop00_sqmi area_pminor area_per_cap_income;
set cumareaa;
maxdif=maxdif/100;
drop pop_m1-pop_m16 pop_mf pop_f1-pop_f16;
run;
proc print;
var minsites;
run;
data a; set cum;
proc sql; select count(*) from a where 
area_perhiskool lt dv_perhiskool; quit; 

 spatial_dv le 15.0 and reg_dv gt 15.0 and